# stream.hpp File Reference

`#include <string>`
`#include <vector>`
`#include <saga/saga/util.hpp>`
`#include <saga/saga/call.hpp>`
`#include <saga/saga/base.hpp>`
`#include <saga/saga/session.hpp>`
`#include <saga/saga/task.hpp>`
`#include <saga/saga/buffer.hpp>`
`#include <saga/saga/url.hpp>`
`#include <saga/saga/context.hpp>`
`#include <saga/saga/detail/attribute.hpp>`
`#include <saga/saga/detail/monitorable.hpp>`
`#include <saga/saga/packages/stream/config.hpp>`

Go to the source code of this file.

## Namespaces
namespace | saga
namespace | saga::stream
namespace | saga::stream::attributes
namespace | saga::stream::metrics
namespace | saga::detail
## Classes
class | saga::stream::stream
| This is the ob ject that encapsulates all client stream ob jects. More...
struct | saga::detail::create_default< saga::stream::stream >
## Enumerations
enum | saga::stream::state { saga::stream::Unknown = -1, saga::stream::New = 1, saga::stream::Open = 2, saga::stream::Closed = 3, saga::stream::Dropped = 4, saga::stream::Error = 5 }
| The Streams API package. More...
enum | saga::stream::activity { saga::stream::Read = 1, saga::stream::Write = 2, saga::stream::Exception = 4 }
| The SAGA stream API allows for event driven communication. More...
## Variables
char const *const | saga::stream::attributes::stream_bufsize = "Bufsize"
char const *const | saga::stream::attributes::stream_timeout = "Timeout"
char const *const | saga::stream::attributes::stream_blocking = "Blocking"
char const *const | saga::stream::attributes::stream_compression = "Compression"
char const *const | saga::stream::attributes::stream_nodelay = "Nodelay"
char const *const | saga::stream::attributes::stream_reliable = "Reliable"
char const *const | saga::stream::metrics::stream_state = "stream.State"
char const *const | saga::stream::metrics::stream_read = "stream.Read"
char const *const | saga::stream::metrics::stream_write = "stream.Write"
char const *const | saga::stream::metrics::stream_exception = "stream.Exception"
char const *const | saga::stream::metrics::stream_dropped = "stream.Dropped"
char const *const | saga::stream::attributes::stream_state_unknown = "Unknown"
char const *const | saga::stream::attributes::stream_state_new = "New"
char const *const | saga::stream::attributes::stream_state_open = "open"
char const *const | saga::stream::attributes::stream_state_closed = "Closed"
char const *const | saga::stream::attributes::stream_state_dropped = "Dropped"
char const *const | saga::stream::attributes::stream_state_error = "Error"